'Test of Emic text-to-speech module driver
'Raymond Allen 2008
'Public Domain


CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency 


OBJ  'Objects Section
    'We need the VGA (or TV) text driver
    
  text : "vga_text"    'For NTSC TV Video: Comment out this line...
  'text : "tv_text"    'and un-comment this line  (need to change pin parameter for text.start(pin) command below too).

  kb : "keyboard"  'using keyboard for test text input
  
  emic:  "Emic_Driver"  'Emic text-speech module interface
  
PUB TestEmic|i,j    'Input text from keyboard and send to Emic on "enter" key

 
  text.start(16)    'Start the VGA/TV text driver (uses another cog)
                    'The parameter (16) is the base pin used by demo and proto boards for VGA output
                    'Change (16) to (12) when using "tv_text" driver with demo board as it uses pin#12 for video


  'init keyboard
  kb.start(26, 27)
  
  'emic.Start(RxPin,TxPin,BusyPin,ResetPin)
  if not emic.start(13,12,14,15)
    text.str(string(13,"Serial Failure."))
    repeat

  'do soft reset (not required)
  emic.SoftReset

  'make some adjustments
  emic.SetSpeed("+")  'make a bit faster
  emic.SetVolume("7") 'loudest

  'Anounce ready
  text.str(@ReadyStr)
  text.out(13)
  emic.say(@ReadyStr, true)


  'main test loop:  Use Emic to say text entered by keyboard
  repeat     'repeat forever
    j:=0  'point to first character in buffer
    i:=0  'make sure i is not 13
    repeat until i==13  'repeat until user hits the enter button (returns 13) 
      repeat while not kb.gotkey  'wait for a key
      i:=kb.getkey  'get key
      text.out(i)  'copy key to video screen
      KeyboardBuffer[j++]:=i  'add to input string buffer
    KeyboardBuffer[j++]:=0  'add null character to terminate string
    emic.say(@KeyboardBuffer, true)  'have emic say text 
          
      
      
        



    
          
DAT
  ReadyStr byte "Ready for keyboard input:",0            'test string
  KeyboardBuffer byte 0[128]                    'keyboard input buffer